program sparse_lab_generator;

{$APPTYPE CONSOLE}

const maxn = 1000;

var
  i, j, n, m, c, tempi: integer;
  a: array[0..maxn, 0..maxn] of char;

begin
  assignfile (output, 'input.txt'); rewrite(output);

  val(paramstr(1), n, tempi);
  val(paramstr(2), m, tempi);
  val(paramstr(3), c, tempi);
  val(paramstr(4), randseed, tempi);

  for i := 1 to n do
    for j := 1 to m do
      a[i][j] := '.';

  for i := 1 to c do
    a[round(random*(n-1)) + 1][round(random*(m-1) + 1)] := '#';

  a[round(random*(n-1)) + 1][round(random*(m-1) + 1)] := 'S';
  a[round(random*(n-1)) + 1][round(random*(m-1) + 1)] := 'F';

  writeln(n, ' ', m);
  for i := 1 to n do
  begin
    for j := 1 to m do
      write(a[i][j]);
    writeln;
  end;

  closefile(output);
end.